<%
'SUBROUTINES DEFINED:
'"""""""""""""""""""
'SetupSessionVariables(AuthUser)		Sets up the session variables
'GetSessionStatusStr()					Returns the error string associated with the session error code
'SetError(Message)						Sets the text of the main error message
'SetReason(Message)						Sets the text of the reason paragraph
'AddFix(Message)						Adds an item to the bulleted list of suggestions
'Check_Browser_Capabilities()			Sets error if the Client browser lacks Tables and JavaScript support
'Invalid_Password()						Sets an error due to an invalid password
'IsConfID()								Sets error if the Conference ID is not set (inConfID)
'ValidateMeetingID()					Sets error if the DCS Meeting ID is not valid (inMeetingID)
'Verify_ConfLocator()					Verifies ConfLocator points to the Conference Locator
'DisplayErrorPage()						Setup the error page when we have an error
'
'FUNCTIONS DEFINED:
'"""""""""""""""""
'CheckSetError(Source, Description) Checks for error values in Result/Err and adds error messages if appropriate
'
' ================================ CONSTANTS =================================================
'ERROR CONSTANTS:
'C++ returns HRESULTS as 4-byte signed ints, so the bit pattern
'0x81000203 comes out as a negative number.
'VBScript also uses 4-byte signed ints, so assigning the bit patterns
'as below makes for better readability while still giving the 
'same negative numbers.
'If VBScript ever changes to use ints larger than 4 bytes, the
'bit patterns below will be interpreted as positive numbers and
'will have to be changed to explicitly reference the negative
'number returned by C++.
CONST E_CMS_EVENTMANAGER_NOT_INITIALIZED                = &H8004100A
CONST E_CMS_CONFERENCE_NOT_SCHEDULED                    = &H8004100B
CONST E_CMS_CONFERENCE_NOT_STARTED                      = &H8004100C
CONST E_CMS_CONFERENCE_NOT_RUNNING                      = &H8004100D
CONST E_CMS_CONFERENCE_NOT_FOUND                        = &H8004100E
CONST E_CMS_INVALID_CONFERENCE_PASSWORD                 = &H8004100F
CONST E_CMS_ANONYMOUS_USER_DENIED_ACCESS                = &H80041010
CONST E_CMS_USER_DENIED_ACCESS                          = &H80041011
CONST E_CMS_CTP_JOIN_REQUEST_FAILED                     = &H80041012
CONST E_CMS_PROVIDER_NOT_INITIALIZED                    = &H80041013
CONST E_CMS_PROVIDER_NOT_FOUND                          = &H80041014
CONST E_CMS_E_CONFERENCE_NOT_EXIST                      = &H80041015
CONST E_CMS_RECURRING_CONFERENCE_NOT_FOUND              = &H80041016
CONST E_CMS_NOT_HOST_SERVER                             = &H80041017
CONST E_CMS_RECURRING_INSTANCE_NOT_WITHIN_TIME_BOUND    = &H80041018
CONST E_CMS_AMBIGUOUS_RECURRING_JOIN                    = &H80041019
CONST E_CMS_TIME_EXTENSIONS_NOT_ALLOWED                 = &H8004101B
CONST E_CMS_RESOURCE_EXTENSIONS_NOT_ALLOWED             = &H8004101C
CONST E_CMS_SERVER_NOT_INITIALIZED                      = &H80041037
CONST E_CMS_PROFILE_STORE_NOT_INITIALIZED               = &H80041038
CONST E_CMS_SHUTTING_DOWN                               = &H4101E

CONST E_DCS_NO_MCUS_AVAILABLE                           = &H8004F001
CONST E_DCS_CONFERENCE_NOT_RUNNING                      = &H8004F002
CONST E_DCS_CONFERENCE_ALREADY_ENDED                    = &H8004F003
CONST E_DCS_ACCESS_DENIED_CAPACITY_LIMIT                = &H8004F004
CONST E_DCS_NO_PROXY_MCUS_AVAILABLE                     = &H8004F005
CONST E_DCS_NO_INTERNET_MCUS_AVAILABLE                  = &H8004F006
CONST E_DCS_NOT_RUNNING                                 = &H8004F007
CONST E_DCS_NOT_INIT                                    = &H8004F008

CONST E_NETMEETING_ERRORS_MASK                          = &H80040300
CONST E_NETMEETING_INVITE_FAILURE                       = &H8004036A
CONST E_NETMEETING_INVITE_TIMEOUT                       = &H80040372

CONST E_PKCS7_NO_CERT_STORE                             = &H80043000
CONST E_SESSION_UNAVAILABLE                             = &H80043001
CONST E_NO_DISPLAY_STATE                                = &H80043002
CONST E_UNSUPPORTED_TABLES_BROWSER                      = &H80043003
CONST E_UNSUPPORTED_JAVASCRIPT_BROWSER                  = &H80043004

CONST E_ACCESS_DENIED                                   = 70 '&H80070005 comes across as error 70 if returned
CONST E_ACCESS_DENIED_HRESULT                           = &H80070005 'if passed back as a result
CONST E_SERVER_CREATE_OBJECT                            = &H800401F3 'Server.CreateObject() error
CONST NM_E_NOT_ACTIVE                                   = &H81000203 'NetMeeting was closed since last use
CONST E_NO_GLOBAL_CONF_CALENDAR                         = &H80010105
CONST E_DSGETSITENAME_NO_SITE                           = &H8007077F
CONST E_MANUAL_JOIN_INSTRUCTIONS                        = &H80040100
CONST E_CMS_RESTARTED                                   = &H1CE

CONST E_MCU_HANG                                        = &H800706BA
CONST E_MCU_NO_SERVER_CERTIFICATE                       = &H80070546

'DISPLAY STATE CONTANTS:
'These define the various display states that can be used
'The quotes are required because the state is passed as a string
'The DCS programmatically uses {0,7,8} so those cannot easily be changed
CONST DISPLAY_JOIN                      = "0"
CONST DISPLAY_JOIN_PASSWORD             = "6"
CONST DISPLAY_PREJOIN                   = "7"
CONST DISPLAY_POSTJOIN                  = "8"
CONST DISPLAY_NO_MADCAP_SERVERS         = "9"
CONST DISPLAY_TOO_MANY_USERS            = "10"
CONST DISPLAY_ALL_MADCAP_SERVERS_FAILED = "11"
CONST DISPLAY_NO_MADCAP_SERVERS_MATCH_SCOPE = "12"
CONST DISPLAY_NO_MADCAP_SCOPES_FOUND    = "13"
CONST DISPLAY_NO_SCOPES_IN_RESOURCE     = "14"
CONST DISPLAY_MAX_JOIN_TYPES            = "14"
CONST DISPLAY_MULTICAST_CLIENT          = "15"
CONST DISPLAY_H323_CLIENT               = "16"
CONST DISPLAY_OLDER_H323_CLIENT         = "51"
CONST DISPLAY_NO_AUDIOVIDEO_CLIENT      = "52"
CONST DISPLAY_NO_AUDIOVIDEO_ACTIVEX     = "53"

CONST DISPLAY_WELCOME                   = "11"
CONST DISPLAY_RECURRING                 = "14"
CONST DISPLAY_AGENDA                    = "17"
CONST DISPLAY_MODIFY                    = "18"
CONST DISPLAY_MAX_NO_JOIN_TYPES         = "19"

CONST DISPLAY_MIN_ERR_TYPES             = "20"
CONST DISPLAY_ERR_CONFID                = "22"
CONST DISPLAY_ERR_CTP_STARTUP           = "23"
CONST DISPLAY_ERR_VALUE                 = "38"
CONST DISPLAY_MAX_ERR_TYPES             = "39"

'SESSION VARIABLE CONSTANTS
CONST SESSION_CONFPROFILE            = "ConfProfile"
CONST SESSION_CONFLOCATOR            = "ConfLocator"
CONST SESSION_CMSZONE                = "CMSZone"
CONST SESSION_CMSCONFIG              = "CMSConfig"
CONST SESSION_MEETINGID              = "MeetingID"
CONST SESSION_RESULT                 = "Result"
CONST SESSION_ERRNUMBER              = "ErrNumber"
CONST SESSION_ERRSOURCE              = "ErrSource"
CONST SESSION_ERRDESCRIPTION         = "ErrDescription"
CONST SESSION_STATUS                 = "Status"
CONST SESSION_ATTENDEE               = "Attendee"
CONST SESSION_PASSWORD				 = "Password"

CONST L_Page_HTMLTitle       = "Conférence Microsoft Exchange"
CONST L_ErrorPage_HTMLTitle  = "Conférence Microsoft Exchange - Erreur"
CONST L_TryTheFollowing_Text = "Essayez l'une des solutions suivantes :"

'Session debugging/status information strings (must stay the same as global.asa)
CONST L_OK_Text                 = "OK"
CONST L_GetConfLocator_Text     = "Impossible d'obtenir l'URL de conférence à partir de la zone de gestion de la conférence"
CONST L_GetZone_Text            = "Impossible de trouver la zone à partir de l'objet de configuration de gestion de la conférence"
CONST L_CreateObject_Text       = "Impossible d'initialiser l'objet de configuration de gestion de la conférence"
CONST L_Unknown_Text            = "Inconnu"
CONST L_Uninitialized_Text      = "Non initialisé"

'Common strings
CONST L_MCUProxyInvite_ErrorMessage     = "Si vous tentez de participer à la conférence par l'intermédiaire d'un serveur proxy, le service de conférence de données peut ne pas arriver à se connecter à votre programme client. Pour connecter manuellement le client de conférence de données, utilisez les informations suivantes :"
CONST L_ManualJoinServer_ErrorMessage   = "Serveur de conférence de données : "
CONST L_ManualJoinID_ErrorMessage       = "ID de conférence : "
CONST L_ManualJoinPassword_ErrorMessage = "Mot de passe de la conférence : "
CONST L_NetMeetingInviteTitle_ErrorMessage  = "Échec de l'invitation à la conférence de données"
CONST L_NetMeetingInviteReason_ErrorMessage = "Le service Conférence de données ne peut pas inviter votre client T.120 (par exemple, Microsoft Netmeeting)."
CONST L_NetMeetingInviteFix1_ErrorMessage   = "Avant de réessayer de vous joindre à la conférence, vérifiez que vous avez bien démarré votre programme client."
CONST L_LinkToConferenceListsFix_ErrorMessage  = "Sélectionnez une conférence en cours à partir de la "
CONST L_LinkToConferenceListsFix2_ErrorMessage = "liste des réunions disponibles."

CONST PR_SUBJECT             = "subject"   'Defines the subject property code for user properties
CONST PR_BODY                = "268435487" 'Defines the body text property code for user properties
CONST PR_BODY_HTML           = "269680670" 'Defines the body text (in HTML) property code for user properties
CONST MAPI_RESOURCE          = "MAPI"      'Defines the resource used when getting user properties

CONST CONF_ID_CODED_LENGTH   = 255 'Length of the Base-64 encoded conference ID
CONST CONF_ID_DECODED_LENGTH = 22 'Conference ID must be 22 digits

' ================================ VARIABLES =================================================
'ERROR VARIABLES:
DIM ErrorMsg        'Holds the main error message (displayed at the top of the error page)
DIM Reason          'Holds the paragraph description of the error (displayed below the main message)
DIM Fixes()         'Holds the suggested remedies (displayed in the bulleted list below the paragraph)
DIM HiddenError     'Holds the system-level error message (displayed in small print at the bottom)
DIM ErrorCount      'Counts the errors encountered (0 or 1)
DIM Result          'Global variable used for function return values
DIM SessionErr(5)   'Holds the error messages that are defined in the session variables code to allow localization

' =============================== INITIALIZATION ==============================================
ErrorMsg        = ""
HiddenError     = ""
Reason          = ""
ErrorCount      = 0
Result          = 0
SessionErr(0)   = L_OK_Text
SessionErr(1)   = L_GetConfLocator_Text
SessionErr(2)   = L_GetZone_Text
SessionErr(3)   = L_CreateObject_Text
SessionErr(4)   = L_Unknown_Text
SessionErr(5)   = L_Uninitialized_Text
REDIM Fixes(0)                          'Puts the array Fixes in a known state

' ================================ FUNCTIONS =================================================
'== SUB: Sets up the session variables (GetSessionStatusStr() is used for SESSION_STATUS strings)
SUB SetupSessionVariables(AuthUser)
    ON ERROR RESUME NEXT

    DIM CMSConfiguration
    DIM CMSZone
    DIM ConfLocator
    
    Session(SESSION_RESULT)          = 0
    Session(SESSION_ERRNUMBER)       = 0
    Session(SESSION_ERRSOURCE)       = 0
    Session(SESSION_ERRDESCRIPTION)  = 0
    Session(SESSION_STATUS)          = 5 'L_Uninitialized_Text
    
    'Create the CMS Configuration object (dllhost will create this from xcmsadm)
    SET CMSConfiguration = Server.CreateObject("XCMSCOM.CMSConfiguration")
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 3 'L_CreateObject_Text
        EXIT SUB
    END IF
    
    SET Session(SESSION_CMSCONFIG) = CMSConfiguration 'Save the singleton CMSConfig for up to 20 mins
    
    'Create the CMS Zone object (dllhost will create this from xcmsadm)
    CALL CMSConfiguration.GetZone("", CMSZone)
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_RESULT)         = Err.Number
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 2 'L_GetZone_Text
        EXIT SUB
    END IF
    
    SET Session(SESSION_CMSZONE) = CMSZone 'Save the CMS Zone object for use later
    
    'Create the Conference Locator object (dllhost will create this from the xconfmgr service)
    CALL CMSZone.GetConferenceLocator(ConfLocator)
    
    IF (0 <> Err.Number) THEN
        Session(SESSION_RESULT)         = Err.Number
        Session(SESSION_ERRNUMBER)      = Err.Number
        Session(SESSION_ERRSOURCE)      = Err.Source
        Session(SESSION_ERRDESCRIPTION) = Err.Description
        Err.Clear()
        Session(SESSION_STATUS)         = 1 'L_GetConfLocator_Text
        EXIT SUB
    END IF

	Session(SESSION_ATTENDEE)		 = AuthUser
	    
    SET Session(SESSION_CONFLOCATOR) = ConfLocator 'Save the Conference Locator for use later
    Session(SESSION_STATUS)          = 0 'L_OK_Text
END SUB

'== SUB: Creates the session status string that we use on the bottom of the error pages
FUNCTION GetSessionStatusStr(errVal)
    IF (errVal >= 0 AND errVal <= 5) THEN
        GetSessionStatusStr = SessionErr(errVal)
    ELSE
        GetSessionStatusStr = errVal
    END IF
END FUNCTION

'== SUB: Sets the text of the main error message
SUB SetError(Message, Value, Source, Description)
    IF (0 = ErrorCount) THEN
        ErrorCount  = ErrorCount + 1
        ErrorMsg    = ErrorMsg & Message
        HiddenError = HiddenError & Source & " Error #" & Hex(Value) & ": " & Description & vbNewLine
    END IF
END SUB

'== SUB: Sets the text of the reason paragraph
SUB SetReason(Message)
    Reason = Message
END SUB

'== SUB: Adds an item to the bulleted list of suggestions
SUB AddFix(Message)
    DIM NewSize
    
    NewSize = UBound(Fixes) + 1
    REDIM PRESERVE Fixes(NewSize)
    
    Fixes(NewSize) = Message
END SUB

'== FUNCTION: Checks for error values in Result/Err and adds error messages if appropriate
FUNCTION CheckSetError(ResultSource, ResultDescription)
    DIM Value, Source, Description
    
    IF (0 <> Err.Number) THEN
        Value       = Err.Number
        Source      = Err.Source & " / [" & ResultSource & "]"
        Description = Err.Description & " / [" & ResultDescription & "]"
        Err.Clear()
    ELSEIF (0 <> Result) THEN
        IF (IsNumeric(Result)) THEN
            Value = CDbl(Result)
        ELSE
            Value = Result
        END IF
        Source      = ResultSource
        Description = ResultDescription
        Result      = 0
    ELSE
        CheckSetError = FALSE
        EXIT FUNCTION
    END IF

    'Bitwise-AND to detect all NetMeeting errors
    IF (E_NETMEETING_ERRORS_MASK = (E_NETMEETING_ERRORS_MASK AND Value)) THEN

        IF (E_NETMEETING_INVITE_FAILURE = Value) THEN
            
            CALL SetError(L_NetMeetingInviteTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteReason_ErrorMessage)
            CALL AddFix(L_NetMeetingInviteFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        ELSEIF (E_NETMEETING_INVITE_TIMEOUT = Value) THEN
            CONST L_NetMeetingInviteTimeoutTitle_ErrorMessage  = "Délai de l'invitation à la conférence de données écoulé"
            CONST L_NetMeetingInviteTimeoutReason_ErrorMessage = "L'invitation envoyée par le serveur de conférence de données a expiré alors que le serveur était en train d'inviter votre programme client (par exemple, Microsoft NetMeeting) à la conférence."
            CONST L_NetMeetingInviteTimeoutFix1_ErrorMessage   = "Rejoignez à nouveau la conférence et acceptez l'invitation du serveur. Il est possible que celle-ci soit masquée par la fenêtre active de votre bureau ; si c'est le cas, ramenez-la au premier plan."
            
            CALL SetError(L_NetMeetingInviteTimeoutTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteTimeoutReason_ErrorMessage)
            CALL AddFix(L_NetMeetingInviteTimeoutFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        ELSE
            CONST L_NetMeetingMaskTitle_ErrorMessage  = "Conflit NetMeeting"
            CONST L_NetMeetingMaskReason_ErrorMessage = "NetMeeting prend le contrôle de certaines ressources sur votre machine ou ne fonctionne pas correctement."
            CONST L_NetMeetingMaskFix1_ErrorMessage   = "Fermez les autres programmes vidéo, audio ou réseau pouvant entrer en conflit avec NetMeeting."
            
            CALL SetError(L_NetMeetingMaskTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingMaskReason_ErrorMessage)
            CALL AddFix(L_NetMeetingMaskFix1_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))
        END IF

        EXIT FUNCTION
    END IF

    SELECT CASE Value
        CASE E_CMS_EVENTMANAGER_NOT_INITIALIZED,E_CMS_SERVER_NOT_INITIALIZED
            CONST L_EventManagerNotInitializedTitle_ErrorMessage  = "Serveur non initialisé"
            CONST L_EventManagerNotInitializedReason_ErrorMessage = "Le service Conférence Microsoft Exchange est en cours de démarrage et n'a pas terminé ce processus."
            CONST L_EventManagerNotInitializedFix1_ErrorMessage   = "Veuillez attendre quelques minutes, puis réessayez."
            
            CALL SetError(L_EventManagerNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_EventManagerNotInitializedReason_ErrorMessage)
            CALL AddFix(L_EventManagerNotInitializedFix1_ErrorMessage)
        
        CASE E_CMS_PROFILE_STORE_NOT_INITIALIZED
            CONST L_ServerOrProfileStoreNotInitializedTitle_ErrorMessage    = "Banque du serveur non initialisée"
            CONST L_ServerOrProfileStoreNotInitializedReason_ErrorMessage   = "Le serveur de conférence Exchange n'est pas initialisé."
            CONST L_ProfileStoreNotInitializedFix1_ErrorMessage             = "Contactez votre administrateur système. Il est possible que la banque de boîtes aux lettres ne soit pas disponible."
                        
            CALL SetError(L_ServerOrProfileStoreNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ServerOrProfileStoreNotInitializedReason_ErrorMessage)
            CALL AddFix(L_ProfileStoreNotInitializedFix1_ErrorMessage)

        CASE E_CMS_CONFERENCE_NOT_RUNNING
            CONST L_ConferenceNotRunningCMSTitle_ErrorMessage  = "Conférence non active"
            CONST L_ConferenceNotRunningCMSReason_ErrorMessage = "La conférence à laquelle vous avez essayé d'accéder n'est pas prête ou un fournisseur de technologie de conférence n'a pas autorisé le démarrage de la conférence."
            CONST L_ConferenceNotRunningCMSFix1_ErrorMessage   = "Veuillez attendre quelques minutes, puis réessayez."
            
            CALL SetError(L_ConferenceNotRunningCMSTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotRunningCMSReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotRunningCMSFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_CONFERENCE_NOT_SCHEDULED
            CONST L_ConferenceNotScheduledTitle_ErrorMessage  = "Conférence non planifiée"
            CONST L_ConferenceNotScheduledReason_ErrorMessage = "Cette conférence (d'après l'ID de conférence inclus dans l'URL) n'a pas été planifiée par le service Conférence Microsoft Exchange."
            CONST L_ConferenceNotScheduledFix1_ErrorMessage   = "La conférence a peut-être été supprimée ou l'ID de conférence est peut-être endommagé."
            CONST L_ConferenceNotScheduledFix2_ErrorMessage   = "Contactez l'organisateur de la réunion ou votre administrateur système."
            
            CALL SetError(L_ConferenceNotScheduledTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotScheduledReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotScheduledFix1_ErrorMessage)
            CALL AddFix(L_ConferenceNotScheduledFix2_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
        
        CASE E_CMS_CONFERENCE_NOT_STARTED
            CONST L_ConferenceNotStartedTitle_ErrorMessage  = "Conférence non démarrée"
            CONST L_ConferenceNotStartedReason_ErrorMessage = "La conférence est en cours de démarrage mais le processus de démarrage n'est pas encore terminé."
            CONST L_ConferenceNotStartedFix1_ErrorMessage   = "Veuillez attendre quelques minutes, puis réessayez."
            
            CALL SetError(L_ConferenceNotStartedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotStartedReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotStartedFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_CONFERENCE_NOT_FOUND,E_CMS_RECURRING_INSTANCE_NOT_WITHIN_TIME_BOUND,E_CMS_AMBIGUOUS_RECURRING_JOIN,E_CMS_E_CONFERENCE_NOT_EXIST,1 'S_FALSE
            CONST L_ConferenceNotFoundTitle_ErrorMessage  = "Conférence introuvable"
            CONST L_ConferenceNotFoundReason_ErrorMessage = "Le service Gestion de conférence ne trouve pas la conférence à laquelle vous essayez de participer."
            CONST L_ConferenceNotFoundFix1_ErrorMessage   = "Si la conférence a été planifiée récemment, attendez quelques minutes, puis réessayez."
            CONST L_ConferenceNotFoundFix2_ErrorMessage   = "Contactez l'organisateur de la conférence car la conférence a peut-être été annulée."
            CONST L_ConferenceNotFoundFix3_ErrorMessage   = "Vérifiez que l'ID de réunion affiché dans l'URL de votre navigateur est le même que celui de la réunion de votre conférence."
            CONST L_ConferenceNotFoundFix4_ErrorMessage   = "Si la réunion est périodique, il est possible qu'il y ait eu des problèmes lors du calcul des périodes."
            
            CALL SetError(L_ConferenceNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotFoundReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix1_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix2_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix3_ErrorMessage)
            CALL AddFix(L_ConferenceNotFoundFix4_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")

        CASE E_CMS_SHUTTING_DOWN
            CONST L_ConfServerShuttingDownTitle_ErrorMessage  = "Arrêt du service Gestion de conférence en cours"
            CONST L_ConfServerShuttingDownReason_ErrorMessage = "Le service Gestion de conférence va s'arrêter."
            CONST L_ConfServerShuttingDownFix1_ErrorMessage   = "Attendez quelques minutes pour que le service redémarre et que la conférence reprenne."
            CONST L_ConfServerShuttingDownFix2_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_ConfServerShuttingDownTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConfServerShuttingDownReason_ErrorMessage)
            CALL AddFix(L_ConfServerShuttingDownFix1_ErrorMessage)
            CALL AddFix(L_ConfServerShuttingDownFix2_ErrorMessage)

        CASE E_CMS_INVALID_CONFERENCE_PASSWORD
            CONST L_InvalidConferencePasswordTitle_ErrorMessage  = "Mot de passe de conférence non valide"
            CONST L_InvalidConferencePasswordReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande de participation à la conférence en raison d'un mot de passe non valide."
            CONST L_InvalidConferencePasswordFix1_ErrorMessage   = "Vérifiez que vous avez entré le mot de passe de conférence approprié."

            CALL SetError(L_InvalidConferencePasswordTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_InvalidConferencePasswordReason_ErrorMessage)
            CALL AddFix(L_InvalidConferencePasswordFix1_ErrorMessage)
        
        CASE E_CMS_ANONYMOUS_USER_DENIED_ACCESS
            CONST L_AnonymousUserDeniedAccessTitle_ErrorMessage  = "Accès anonyme refusé"
            CONST L_AnonymousUserDeniedAccessReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande de participation à la conférence car il est impossible de vous identifier."
            CONST L_AnonymousUserDeniedAccessFix1_ErrorMessage   = "Vérifiez que vous n'essayez pas de participer à une conférence privée à laquelle vous n'avez pas été invité."
            CONST L_AnonymousUserDeniedAccessFix2_ErrorMessage   = "Vérifiez que vous avez ouvert une session sur le réseau à votre nom et que vous pouvez être identifié."

            CALL SetError(L_AnonymousUserDeniedAccessTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_AnonymousUserDeniedAccessReason_ErrorMessage)
            CALL AddFix(L_AnonymousUserDeniedAccessFix1_ErrorMessage)
            CALL AddFix(L_AnonymousUserDeniedAccessFix2_ErrorMessage)
        
        CASE E_CMS_USER_DENIED_ACCESS
            CONST L_UserDeniedAccessTitle_ErrorMessage  = "Accès refusé"
            CONST L_UserDeniedAccessReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande de participation à la conférence car vous ne disposiez pas de l'autorisation nécessaire. Vous avez été authentifié en tant que :"
            CONST L_UserDeniedAccessFix1_ErrorMessage   = "Vérifiez que vous n'essayez pas de participer à une conférence privée à laquelle vous n'avez pas été invité. Reprenez l'invitation originale et vérifiez que la case Accepter les participants étrangers est bien activée. Vérifiez que votre nom d'utilisateur figure dans la liste À ou Cc, et que vous vous êtes authentifié au serveur par ce nom."
            CONST L_UserDeniedAccessFix2_ErrorMessage   = "Contactez votre administrateur système. Les autorisations de racine virtuelle de conférence n'ont peut-être pas été définies correctement, ou le service Gestion de conférence est peut-être en train de forcer des authentifications client pour des conférences privées (la case Authentifier l'accès aux pages de réunion privées est activée)."

            CALL SetError(L_UserDeniedAccessTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_UserDeniedAccessReason_ErrorMessage & Request.ServerVariables("AUTH_USER"))
            CALL AddFix(L_UserDeniedAccessFix1_ErrorMessage)
            CALL AddFix(L_UserDeniedAccessFix2_ErrorMessage)

        CASE E_CMS_CTP_JOIN_REQUEST_FAILED
            CONST L_CTPJoinRequestFailedTitle_ErrorMessage  = "Demande de participation refusée par FTC"
            CONST L_CTPJoinRequestFailedReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande de participation à la conférence car le fournisseur de technologie de conférence ne vous autorise pas à y participer."
            CONST L_CTPJoinRequestFailedFix1_ErrorMessage   = "Contactez votre administrateur système."

            CALL SetError(L_CTPJoinRequestFailedTitle_ErrorMessage, Value, Replace(Request.QueryString("PNAME"), "+"," "), Description)
            CALL SetReason(L_CTPJoinRequestFailedReason_ErrorMessage)
            CALL AddFix(L_CTPJoinRequestFailedFix1_ErrorMessage)
        
        CASE E_CMS_PROVIDER_NOT_INITIALIZED
            CONST L_ProviderNotInitializedTitle_ErrorMessage  = "Fournisseur non initialisé"
            CONST L_ProviderNotInitializedReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande de participation à la conférence car le fournisseur de technologie de conférence n'a pas terminé son initialisation."
            CONST L_ProviderNotInitializedFix1_ErrorMessage   = "Contactez votre administrateur système."

            CALL SetError(L_ProviderNotInitializedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ProviderNotInitializedReason_ErrorMessage)
            CALL AddFix(L_ProviderNotInitializedFix1_ErrorMessage)
        
        CASE E_CMS_PROVIDER_NOT_FOUND
            CONST L_ProviderNotFoundTitle_ErrorMessage  = "Fournisseur introuvable"
            CONST L_ProviderNotFoundReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande de participation à la conférence car aucun fournisseur de technologie de conférence n'a pu être contacté."
            CONST L_ProviderNotFoundFix1_ErrorMessage   = "Contactez votre administrateur système."

            CALL SetError(L_ProviderNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ProviderNotFoundReason_ErrorMessage)
            CALL AddFix(L_ProviderNotFoundFix1_ErrorMessage)
        
        CASE E_CMS_RECURRING_CONFERENCE_NOT_FOUND
            CONST L_RecurringConferenceNotFoundTitle_ErrorMessage  = "Conférence périodique introuvable"
            CONST L_RecurringConferenceNotFoundReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande car il ne trouve pas la conférence périodique voulue."
            CONST L_RecurringConferenceNotFoundFix1_ErrorMessage   = "Contactez votre administrateur système."

            CALL SetError(L_RecurringConferenceNotFoundTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_RecurringConferenceNotFoundReason_ErrorMessage)
            CALL AddFix(L_RecurringConferenceNotFoundFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
        
        CASE E_CMS_NOT_HOST_SERVER
            CONST L_NotHostServerTitle_ErrorMessage  = "URL de l'hôte incorrecte"
            CONST L_NotHostServerReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande car ce serveur n'est pas le serveur hôte."
            CONST L_NotHostServerFix1_ErrorMessage   = "Contactez votre administrateur système."

            CALL SetError(L_NotHostServerTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NotHostServerReason_ErrorMessage)
            CALL AddFix(L_NotHostServerFix1_ErrorMessage)

        CASE E_DCS_NO_MCUS_AVAILABLE
            CONST L_NoAvailableMCUsTitle_ErrorMessage  = "Pas de serveur MCU T.120 disponible"
            CONST L_NoAvailableMCUsReason_ErrorMessage = "Le service Conférence de données n'est pas disponible ou pas configuré pour permettre une connexion au serveur  MCU T.120 à partir de votre adresse. Pour participer à une conférence, le client de conférence de données (par exemple NetMeeting) doit se connecter à un serveur MCU T.120."
            CONST L_NoAvailableMCUsFix1_ErrorMessage   = "Si ce problème persiste, contactez votre administrateur système."
            
            CALL SetError(L_NoAvailableMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableMCUsFix1_ErrorMessage)

        CASE E_DCS_NO_PROXY_MCUS_AVAILABLE
            CONST L_NoAvailableProxyMCUsTitle_ErrorMessage  = "Aucun serveur proxy MCU T.120 disponible"
            CONST L_NoAvailableProxyMCUsReason_ErrorMessage = "Le service Conférence de données n'est pas disponible ou pas configuré pour permettre une connexion à un serveur proxy MCU T.120 à partir de votre site Windows 2000. La participation à une conférence sur un autre site requiert une connexion à un serveur proxy MCU T.120."
            CONST L_NoAvailableProxyMCUsFix1_ErrorMessage   = "Si ce problème persiste, contactez votre administrateur système."
            
            CALL SetError(L_NoAvailableProxyMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableProxyMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableProxyMCUsFix1_ErrorMessage)

        CASE E_DCS_NO_INTERNET_MCUS_AVAILABLE
            CONST L_NoAvailableInternetMCUsTitle_ErrorMessage  = "Aucun serveur Internet MCU T.120 disponible"
            CONST L_NoAvailableInternetMCUsReason_ErrorMessage = "Le service Conférence de données n'est pas disponible ou pas configuré pour permettre une connexion à un serveur Internet MCU T.120 en dehors de l'organisation. La participation à une conférence dans une autre organisation requiert une connexion à un serveur Internet MCU T.120."
            CONST L_NoAvailableInternetMCUsFix1_ErrorMessage   = "Si ce problème persiste, contactez votre administrateur système."
            
            CALL SetError(L_NoAvailableInternetMCUsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoAvailableInternetMCUsReason_ErrorMessage)
            CALL AddFix(L_NoAvailableInternetMCUsFix1_ErrorMessage)

        CASE E_DCS_CONFERENCE_NOT_RUNNING
            CONST L_ConferenceNotRunningDCSTitle_ErrorMessage  = "Conférence non active"
            CONST L_ConferenceNotRunningDCSReason_ErrorMessage = "La conférence n'est pas active sur le serveur MCU T.120."
            CONST L_ConferenceNotRunningDCSFix1_ErrorMessage   = "Si ce problème persiste, contactez votre administrateur système."
            
            CALL SetError(L_ConferenceNotRunningDCSTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceNotRunningDCSReason_ErrorMessage)
            CALL AddFix(L_ConferenceNotRunningDCSFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
            
        CASE E_DCS_CONFERENCE_ALREADY_ENDED
            CONST L_ConferenceAlreadyEndedTitle_ErrorMessage  = "Conférence terminée"
            CONST L_ConferenceAlreadyEndedReason_ErrorMessage = "La conférence de données à laquelle vous avez essayé de participer n'est plus active."
            CONST L_ConferenceAlreadyEndedFix1_ErrorMessage   = "Si ce problème persiste, contactez votre administrateur système."
            
            CALL SetError(L_ConferenceAlreadyEndedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ConferenceAlreadyEndedReason_ErrorMessage)
            CALL AddFix(L_ConferenceAlreadyEndedFix1_ErrorMessage)
            CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
            
        CASE E_DCS_ACCESS_DENIED_CAPACITY_LIMIT
            CONST L_CapacityLimitTitle_ErrorMessage  = "Limite de capacité de la conférence de données"
            CONST L_CapacityLimitReason_ErrorMessage = "La conférence de données a atteint sa limite de capacité et ne peut plus accepter de nouveaux utilisateurs pour le moment."
            CONST L_CapacityLimitFix1_ErrorMessage   = "Attendez quelques minutes, puis réessayez de participer à la conférence. D'autres utilisateurs auront peut-être quitté la conférence entre-temps."
            CONST L_CapacityLimitFix2_ErrorMessage   = "Contactez l'organisateur de la réunion."
            
            CALL SetError(L_CapacityLimitTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_CapacityLimitReason_ErrorMessage)
            CALL AddFix(L_CapacityLimitFix1_ErrorMessage)
            CALL AddFix(L_CapacityLimitFix2_ErrorMessage)

        CASE E_DCS_NOT_RUNNING
            CONST L_DCSNotRunningTitle_ErrorMessage  = "Service Conférence de données non actif"
            CONST L_DCSNotRunningReason_ErrorMessage = "Le service Conférence de données n'est pas actif actuellement."
            CONST L_DCSNotRunningFix1_ErrorMessage   = "Attendez quelques minutes, puis réessayez de participer à la conférence. Le service est peut-être en cours de redémarrage."
            CONST L_DCSNotRunningFix2_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_DCSNotRunningTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DCSNotRunningReason_ErrorMessage)
            CALL AddFix(L_DCSNotRunningFix1_ErrorMessage)
            CALL AddFix(L_DCSNotRunningFix2_ErrorMessage)

        CASE E_DCS_NOT_INIT
            CONST L_DCSNotInitTitle_ErrorMessage  = "Service Conférence de données non initialisé"
            CONST L_DCSNotInitReason_ErrorMessage = "Le service Conférence de données n'a pas terminé son initialisation."
            CONST L_DCSNotInitFix1_ErrorMessage   = "Attendez quelques minutes, puis réessayez de participer à la conférence."
            CONST L_DCSNotInitFix2_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_DCSNotInitTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DCSNotInitReason_ErrorMessage)
            CALL AddFix(L_DCSNotInitFix1_ErrorMessage)
            CALL AddFix(L_DCSNotInitFix2_ErrorMessage)

        CASE E_PKCS7_NO_CERT_STORE
            CONST L_NoCertStoreTitle_ErrorMessage    = "Erreur lors de l'ouverture de la banque d'informations de certificats"
            CONST L_NoCertStoreReason_ErrorMessage   = "Une erreur est survenue lors de l'ouverture de la banque d'informations sur le serveur de gestion de la conférence à laquelle vous avez essayé de participer."
            CONST L_NoCertStoreFix1_ErrorMessage     = "Contactez votre administrateur système."

            CALL SetError(L_NoCertStoreTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoCertStoreReason_ErrorMessage)
            CALL AddFix(L_NoCertStoreFix1_ErrorMessage)
        
        CASE E_MCU_NO_SERVER_CERTIFICATE
            CONST L_NoServerCertificateTitle_ErrorMessage    = "Aucun certificat de serveur de conférence de données"
            CONST L_NoServerCertificateReason_ErrorMessage   = "Actuellement, le serveur de conférence de données Exchange ne peut pas fournir de conférences privées."
            CONST L_NoServerCertificateFix1_ErrorMessage     = "Contactez votre administrateur système pour vous assurer qu'un certificat de l'ordinateur est installé sur le serveur de conférence de données."

            CALL SetError(L_NoServerCertificateTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoServerCertificateReason_ErrorMessage)
            CALL AddFix(L_NoServerCertificateFix1_ErrorMessage)

        CASE E_MANUAL_JOIN_INSTRUCTIONS            
            CONST L_ManualJoinInstructionsTitle_ErrorMessage  = "Joindre les instructions"
            CALL SetError(L_ManualJoinInstructionsTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NetMeetingInviteReason_ErrorMessage)
            CALL AddFix(L_MCUProxyInvite_ErrorMessage)
            CALL AddFix(L_ManualJoinServer_ErrorMessage & Session("MCUAddress"))
            CALL AddFix(L_ManualJoinID_ErrorMessage & Request.QueryString("ID"))
            CALL AddFix(L_ManualJoinPassword_ErrorMessage & Session(SESSION_PASSWORD))


        CASE E_SESSION_UNAVAILABLE
        
            SELECT CASE Session(SESSION_RESULT)

                CASE &H8007000E
                    CONST L_SessionUnavailableResoveHostTitle_ErrorMessage    = "Impossible de trouver l'hôte"
                    CONST L_SessionUnavailableResoveHostReason_ErrorMessage   = "Une erreur s'est produite sur le serveur Web de Conférence Microsoft Exchange. Le serveur n'a pas pu trouver le nom de l'hôte pour le serveur d'annuaires."
                    CONST L_SessionUnavailableResoveHostFix1_ErrorMessage     = "Contactez votre administrateur système."

                    CALL SetError(L_SessionUnavailableResoveHostTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableResoveHostReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableResoveHostFix1_ErrorMessage)

                CASE &H8000FFFF
                    CONST L_SessionUnavailableNoRightsTitle_ErrorMessage    = "Droits insuffisants"
                    CONST L_SessionUnavailableNoRightsReason_ErrorMessage   = "Une erreur s'est produite sur le serveur Web de Conférence Microsoft Exchange.  Vous ne disposiez pas de suffisamment de droits pour accéder au serveur d'annuaires. Il se peut que les paramètres de compte IIS par défaut ou les paramètres de sécurité du serveur d'annuaires soient configurés de manière incorrecte."
                    CONST L_SessionUnavailableNoRightsFix1_ErrorMessage     = "Contactez votre administrateur système."

                    CALL SetError(L_SessionUnavailableNoRightsTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableNoRightsReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableNoRightsFix1_ErrorMessage)

                CASE &H800704E1
                    CONST L_SessionUnavailableBadSiteTitle_ErrorMessage    = "Site non valide"
                    CONST L_SessionUnavailableBadSiteReason_ErrorMessage   = "Une erreur s'est produite sur le serveur Web de Conférence Exchange. Le service a tenté de consulter un site introuvable dans une zone."
                    CONST L_SessionUnavailableBadSiteFix1_ErrorMessage     = "Contactez votre administrateur système."

                    CALL SetError(L_SessionUnavailableBadSiteTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableBadSiteReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableBadSiteFix1_ErrorMessage)
            
                CASE ELSE
                    CONST L_SessionUnavailableTitle_ErrorMessage    = "Serveur non disponible"
                    CONST L_SessionUnavailableReason_ErrorMessage   = "Le serveur Web de Conférence Microsoft Exchange n'est pas disponible."
                    CONST L_SessionUnavailableFix1_ErrorMessage     = "Fermez votre navigateur et recommencez l'opération."
                    CONST L_SessionUnavailableFix2_ErrorMessage     = "Contactez votre administrateur système."

                    CALL SetError(L_SessionUnavailableTitle_ErrorMessage, Value, Source, Description)
                    CALL SetReason(L_SessionUnavailableReason_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableFix1_ErrorMessage)
                    CALL AddFix(L_SessionUnavailableFix2_ErrorMessage)
        
            END SELECT
        
        CASE E_SERVER_CREATE_OBJECT
            CONST L_ServerCreateObjectTitle_ErrorMessage  = "Erreur de configuration du serveur Web"
            CONST L_ServerCreateObjectReason_ErrorMessage = "Le serveur Web auquel vous avez essayé de vous connecter n'est pas configuré pour fonctionner avec les composants du service Conférence Microsoft Exchange."
            CONST L_ServerCreateObjectFix1_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_ServerCreateObjectTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_ServerCreateObjectReason_ErrorMessage)
            CALL AddFix(L_ServerCreateObjectFix1_ErrorMessage)

        CASE E_UNSUPPORTED_JAVASCRIPT_BROWSER
            CONST L_JavaScriptRequiredTitle_ErrorMessage  = "Prise en charge de JavaScript requise"
            CONST L_JavaScriptRequiredReason_ErrorMessage = "Pour afficher cette page, vous devez utiliser un navigateur compatible avec JavaScript, tel que Internet Explorer 5.0."
            CONST L_JavaScriptRequiredFix1_ErrorMessage   = "<A HREF=""http://www.microsoft.com/ie"">Obtenir Internet Explorer</A>."
        
            CALL SetError(L_JavaScriptRequiredTitle_ErrorMessage, 0, "Browser", "Browser doesn't support javascript")
            CALL SetReason(L_JavaScriptRequiredReason_ErrorMessage)
            CALL AddFix(L_JavaScriptRequiredFix1_ErrorMessage)

        CASE E_UNSUPPORTED_TABLES_BROWSER
            CONST L_TablesRequiredTitle_ErrorMessage  = "Prise en charge des tableaux requise"
            CONST L_TablesRequiredReason_ErrorMessage = "Pour afficher cette page, vous devez utiliser un navigateur qui prend en charge les tableaux, tel que Internet Explorer 5.0."
            CONST L_TablesRequiredFix1_ErrorMessage   = "<A HREF=""http://www.microsoft.com/ie"">Obtenir Internet Explorer</A>."
        
            CALL SetError(L_TablesRequiredTitle_ErrorMessage, 0, "Browser", "Browser doesn't support tables")
            CALL SetReason(L_TablesRequiredReason_ErrorMessage)
            CALL AddFix(L_TablesRequiredFix1_ErrorMessage)

        CASE E_ACCESS_DENIED
            CONST L_AccessDeniedTitle_ErrorMessage  = "Accès refusé"
            CONST L_AccessDeniedReason_ErrorMessage = "Le service Gestion de conférence a refusé votre demande en raison d'une absence d'autorisations."
            CONST L_AccessDeniedFix1_ErrorMessage   = "Vérifiez que vous utilisez le mot de passe correct (si la conférence requiert un mot de passe)."
            CONST L_AccessDeniedFix2_ErrorMessage   = "Vérifiez que vous n'essayez pas de participer à une conférence privée à laquelle vous n'avez pas été invité."
            CONST L_AccessDeniedFix3_ErrorMessage   = "Contactez votre administrateur système."

            Err.Number = E_ACCESS_DENIED_HRESULT 'Set for better display
            CALL SetError(L_AccessDeniedTitle_ErrorMessage, Value, Source, Description)
            Err.Number = E_ACCESS_DENIED 'Reset for no complications
            CALL SetReason(L_AccessDeniedReason_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix1_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix2_ErrorMessage)
            CALL AddFix(L_AccessDeniedFix3_ErrorMessage)

        CASE E_CMS_RESTARTED
            CONST L_CMSRestartedTitle_ErrorMessage  = "Erreur lors de la connexion au service de Conférence Exchange "
            CONST L_CMSRestartedReason_ErrorMessage = "Le service de Conférence Exchange n'est pas disponible actuellement."
            CONST L_CMSRestartedFix1_ErrorMessage   = "Fermez votre navigateur et établissez une nouvelle connexion au service de Conférence Exchange."
            CONST L_CMSRestartedFix2_ErrorMessage   = "Contactez votre administrateur si vous ne parvenez toujours pas à vous connecter. Le service n'est peut-être pas actif."
            
            CALL SetError(L_CMSRestartedTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_CMSRestartedReason_ErrorMessage)
            CALL AddFix(L_CMSRestartedFix1_ErrorMessage)
            CALL AddFix(L_CMSRestartedFix2_ErrorMessage)
        
        CASE E_MCU_HANG
            CONST L_MCUHangTitle_ErrorMessage  = "Erreur lors de la connexion au serveur de conférence de données"
            CONST L_MCUHangReason_ErrorMessage = "Le service de Conférence Exchange a rencontré une erreur en travaillant avec le serveur de conférence de données."
            CONST L_MCUHangFix1_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_MCUHangTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_MCUHangReason_ErrorMessage)
            CALL AddFix(L_MCUHangFix1_ErrorMessage)

        CASE E_NO_GLOBAL_CONF_CALENDAR
            CONST L_NoGlobalConfCalTitle_ErrorMessage  = "Le service Conférence Microsoft Exchange est configuré de manière incorrecte"
            CONST L_NoGlobalConfCalReason_ErrorMessage = "Il est possible qu'aucune boîte aux lettres de conférence par défaut ne soit définie pour le service Conférence Microsoft Exchange."
            CONST L_NoGlobalConfCalFix1_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_NoGlobalConfCalTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_NoGlobalConfCalReason_ErrorMessage)
            CALL AddFix(L_NoGlobalConfCalFix1_ErrorMessage)

        CASE E_DSGETSITENAME_NO_SITE
            CONST L_DsGetSiteNameTitle_ErrorMessage  = "Site non trouvé"
            CONST L_DsGetSiteNameReason_ErrorMessage = "Le service de conférence Exchange ne peut pas trouver son serveur Active Directory."
            CONST L_DsGetSiteNameFix1_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_DsGetSiteNameTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DsGetSiteNameReason_ErrorMessage)
            CALL AddFix(L_DsGetSiteNameFix1_ErrorMessage)

        CASE ELSE 'OTHER ERRORS
                    
            CONST L_DefaultTitle_ErrorMessage  = "Erreur de serveur"
            CONST L_DefaultReason_ErrorMessage = "Le service Conférence Microsoft Exchange a rencontré une erreur de serveur."
            CONST L_DefaultFix1_ErrorMessage   = "Contactez votre administrateur système."
            
            CALL SetError(L_DefaultTitle_ErrorMessage, Value, Source, Description)
            CALL SetReason(L_DefaultReason_ErrorMessage)
            CALL AddFix(L_DefaultFix1_ErrorMessage)

    END SELECT

    CheckSetError = Value
END FUNCTION

'== SUB: Verifies ConfLocator points to the Conference Locator
SUB Verify_ConfLocator()
    ON ERROR RESUME NEXT

	DIM AuthUser
    
	AuthUser	=  Request.ServerVariables("AUTH_USER")
    IF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) OR 0 <> Session(SESSION_ERRNUMBER) OR NOT IsObject(Session(SESSION_CONFLOCATOR)) OR NOT IsObject(Session(SESSION_CMSZONE)) OR (AuthUser <> "" AND LCase(AuthUser) <> LCase(Session(SESSION_ATTENDEE)))) THEN
        CALL SetupSessionVariables(AuthUser)
    END IF
    
    IF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) AND 0 <> Session(SESSION_ERRNUMBER)) THEN
        Err.Number      = Session(SESSION_ERRNUMBER)
        Err.Description = Session(SESSION_ERRDESCRIPTION)
        Err.Source      = Session(SESSION_ERRSOURCE)
    ELSEIF (L_OK_Text <> GetSessionStatusStr(Session(SESSION_STATUS)) OR NOT IsObject(Session(SESSION_CONFLOCATOR)) OR NOT IsObject(Session(SESSION_CMSZONE))) THEN
        Result          = E_SESSION_UNAVAILABLE
    END IF
END SUB

'== SUB: Sets error if the Client browser lacks Tables and JavaScript support
SUB Check_Browser_Capabilities()
    DIM Browscap
    
    SET Browscap = Server.CreateObject("MSWC.BrowserType")

    ' No longer trying to detect javascript from the browser (wasn't working with Navigator)
    'IF (0 = Browscap.JavaScript) THEN
    '    displayState = DISPLAY_ERR_VALUE
    '    Err.Number   = E_UNSUPPORTED_JAVASCRIPT_BROWSER
    'ELSE
    IF (0 = Browscap.tables) THEN
        displayState = DISPLAY_ERR_VALUE
        Err.Number   = E_UNSUPPORTED_TABLES_BROWSER
    END IF
END SUB

'== SUB: Sets an error due to an invalid password
SUB Invalid_Password()
    CONST L_IncorrectPasswordTitle_ErrorMessage  = "Mot de passe incorrect"
    CONST L_IncorrectPasswordReason_ErrorMessage = "Vous n'avez pas entré le mot de passe requis pour la participation à cette conférence. Si vous avez tapé l'URL ci-dessus, vérifiez cette URL. Vous avez peut-être tapé le mot de passe de manière incorrecte."
    CONST L_IncorrectPasswordFix1_ErrorMessage   = "Vérifiez le texte tapé."
    CONST L_IncorrectPasswordFix2_ErrorMessage   = "Contactez l'organisateur de la conférence ou votre administrateur système."
        
    CALL SetError(L_IncorrectPasswordTitle_ErrorMessage, 0, "Security", "Invalid Password")
    CALL SetReason(L_IncorrectPasswordReason_ErrorMessage)
    CALL AddFix(L_IncorrectPasswordFix1_ErrorMessage)
    CALL AddFix(L_IncorrectPasswordFix2_ErrorMessage)
END SUB

'== SUB: Sets error if the Conference ID is not set
SUB IsConfID()
    IF ("" = inConfID OR CONF_ID_CODED_LENGTH < Len(inConfID)) THEN
        displayState = DISPLAY_ERR_CONFID
    END IF
END SUB

'== SUB: Sets error if the DCS Meeting ID is not valid
SUB ValidateMeetingID()
    IF (CONF_ID_DECODED_LENGTH <> Len(inMeetingID)) THEN
        CONST L_NoConferenceIDTitle_ErrorMessage  = "URL d'accès à la conférence non valide"
        CONST L_NoConferenceIDReason_ErrorMessage = "Vous ne pouvez participer à une conférence qu'avec une URL d'accès valide."
        CONST L_NoConferenceIDFix1_ErrorMessage   = "Si vous avez copié l'URL, vérifiez le libellé de l'URL. Vous pouvez aussi participer à une conférence à laquelle vous avez été invité par courrier électronique."

        Err.Number      = Len(inMeetingID)
        Err.Description = "Invalid conference ID"
        Err.Source      = "Exchange Conferencing Service"
        CALL SetError(L_NoConferenceIDTitle_ErrorMessage, 0, "Validate Meeting ID", "Invalid Conference ID")
        CALL SetReason(L_NoConferenceIDReason_ErrorMessage)
        CALL AddFix(L_NoConferenceIDFix1_ErrorMessage)
        CALL AddFix(L_LinkToConferenceListsFix_ErrorMessage & "<A HREF=""list.asp"">" & L_LinkToConferenceListsFix2_ErrorMessage & "</A>")
    END IF
END SUB

'== SUB: Setup the error page when we have an error
SUB DisplayErrorPage() %>
<TITLE><%=L_ErrorPage_HTMLTitle%></TITLE>
</HEAD>
<body BGCOLOR="#FFFFFF" BACKGROUND="filespw.gif" LEFTMARGIN="40" RIGHTMARGIN="40" TEXT="#000000" LINK="#000000" ALINK="#FFCC66" VLINK="#0080FF" STYLE="background-color:#FFFFFF; background-image:url(filespw.gif); background-attachment:fixed; background-repeat:no-repeat; background-position:bottom right;">

<center>
<table CELLSPACING="12">
<tr><td COLSPAN="2" ROWSPAN="1" ALIGN="LEFT"><b><font FACE="verdana" SIZE="+3"><%=ErrorMsg%></font></b></td></tr>
<tr><td COLSPAN="2" ROWSPAN="1" ALIGN="LEFT"><font FACE="verdana" SIZE="-1">
    <%=Reason%>
    <P><%=L_TryTheFollowing_Text%></P>
    <UL>
        <%
            DIM count
            FOR count = 1 TO UBound(Fixes)
                Response.write("<LI>" + Fixes(count) + "</LI>")
            NEXT
        %>
    </UL>
    <P>
    <SMALL>
        <%=HiddenError%>
        <BR>
        <%=L_Page_HTMLTitle%>
    </SMALL>
</font></td></tr>
</table>
</center>
</body>
</HTML>
<% END SUB %>
